SystemOrganization addCategory: #'GMF-Facade'!

Object subclass: #Facade
	instanceVariableNames: ''
	classVariableNames: 'UMLElements dataModel'
	poolDictionaries: ''
	category: 'GMF-Facade'!

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:12'!
addAssociation: xDataClass
	self checkNill.
	dataModel addAssociation: xDataClass! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:12'!
addClass: xDataClass
	self checkNill.
	dataModel addClass: xDataClass! !

!Facade class methodsFor: 'private' stamp: 'RostislavNovak 11/28/2013 20:31'!
checkNill
	dataModel ifNil: [ dataModel := DataModel new ].! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/25/2013 21:10'!
clearData
	dataModel := DataModel new.! !

!Facade class methodsFor: 'accessing' stamp: 'volosmat 12/4/2013 12:50'!
clearPackage: packageName
	| package |
	package := PackageInfo named: packageName.
	package definedClasses
		do: [:classToRemove | classToRemove removeFromSystem]! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/28/2013 20:32'!
generate
	| data |
	self checkNill.
	UMLElements := TransformToUML dataToTransform: dataModel asMetaModel modelElements.
	UMLElements transformAll.
	data := DataForGenerator UMLModel: UMLElements transformedElements.
	UMLElements dataForGenerator: data dataForGenerator.
	CodeGenerator setDataWithAll: UMLElements dataForGenerator.
	^ true! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:32'!
getAssociation: xName start: aName end: bName
	self checkNill.
	^ dataModel associations
		detect: [ :e | 
			xName = e metaModelClass name.
			aName = ((e metaModelClass) start) name.
			bName = e metaModelClass end name ]
		ifNone: [  ]! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:18'!
getClass: xName
	self checkNill.
	^ dataModel elements detect:  [ :e | xName = e metaModelClass name ]  ifNone: [].! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/28/2013 20:32'!
getClasses
	self checkNill.
	^ dataModel elements! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/28/2013 20:32'!
getDiagram
	self checkNill.
	^dataModel! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/25/2013 21:26'!
loadDiagram! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:14'!
removeAssociation: xGMFGACover
	self checkNill.
	dataModel removeAssociation: xGMFGACover! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 12/18/2013 01:14'!
removeClass: xGMFGACover
	self checkNill.
	dataModel removeClass: xGMFGACover! !

!Facade class methodsFor: 'accessing' stamp: 'RostislavNovak 11/25/2013 21:26'!
saveDiagram! !
